#ifndef DEFINED_CRC8_MAXIM
#define DEFINED_CRC8_MAXIM
/*
 * http://www.datastat.com/sysadminjournal/maximcrc.cgi
 * http://stackoverflow.com/questions/29214301/ios-how-to-calculate-crc-8-dallas-maxim-of-nsdata
 * http://fabionotes.blogspot.de/2012/07/8-bit-dallas-maxim-crc.html
 * https://de.wikipedia.org/wiki/Zyklische_Redundanzpr%C3%BCfung
 */
#include <stdint.h>
class Crc8Maxim
{
private:
    uint8_t m_crc;
    static const uint8_t L[16];
    static const uint8_t H[16];
public:
    Crc8Maxim();
    void update (uint8_t data);
    void update (const uint8_t *data, const uint16_t size);
    uint8_t crc() const { return m_crc; }
};
#endif /* DEFINED_CRC8_MAXIM */
