#ifndef DEFINED_SERIAL_WING_INTERFACE
#define DEFINED_SERIAL_WING_INTERFACE
/*
 * UART Multidrop Protocol - UMP
 *
 * crc8: crc8-maxim
 *
 * Frame <u8:0x55> <u8:0xAA> <u8:sender> | <8:destination> <8:flags/type> <8:size> <8:header-crc> | [<u8:data>]{size} <u8:payload-crc>
 *
 * header-crc = {sender,destination,flags,size}
 * payload-crc = {data}
 */

namespace UartMultidropProtocol
{
    class Frame
    {
    public:
	unsigned char source;
	unsigned char dest;
	unsigned char flags;
	unsigned char size; // size of the payload
	unsigned char data[256+10];
	
	const unsigned long frameSize() const;
    };

    class UmpInterface_p;
    class UmpInterface
    {
    private:
	UmpInterface_p & m_p;
    public:
	UmpInterface();
	~UmpInterface();
	void setSerialName(const char *_serialName);
	void setFrameSocket(const int _socket);
	bool start();
    };
};

#endif // DEFINED_SERIAL_WING_INTERFACE
